<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: admin.php
# Path: admin/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006-2007 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: admin.php
# Path: admin/
# Version: 2.0.4
######################################################################

define ('SN_SiteSystemAdmin', true);
define ('SN_PathRoot', realpath (dirname (__FILE__).'/../').'/');
include (SN_PathRoot.'inc/common.php');
unset ($access);

if (!file_exists (SN_PathRootAdmin.'admin.php')) {
   echo "Eror! Path is false.";
   exit;
}

if (file_exists (SN_PathRootAdmin.'lang/lang-'._SNSS_LANG.'.php')) {
   include_once (SN_PathRootAdmin.'lang/lang-'._SNSS_LANG.'.php');
} else {
   echo "Eror! Lang file is absent";
   exit;
}

include (SN_PathRoot.'inc/function/system.php');

if (isset ($_POST['enter_admin'])) {
   $admin_name = isset ($_POST['admin_name']) ? substr (str_replace ("\\'", "''", str_replace ("'", "\'", rtrim (htmlspecialchars (str_replace ("\'", "'", trim (strip_tags ($_POST['admin_name'])))), "\\"))), 0, 15) : '';
   $code_password = isset ($_POST['admin_password']) ? md5 (trim ($_POST['admin_password'])) : '';
   if ('' == $admin_name || '' == $code_password || md5('') == $code_password) { header ('Location: admin.php'); exit; }
   if ($row = $db->sql_fetchrow ($db->sql_query ("SELECT admin_id, login, admin_fullname, password FROM ".SN_TABLE_ADMINS." WHERE login='".$admin_name."' AND password='".$code_password."'"))) {
      mt_srand ((double)microtime ()*1000000);
      $maxran = 1000000;
      $checknum = mt_rand (0, $maxran);
      $checknum = md5 ($checknum);
      $agent = substr (trim ($_SERVER['HTTP_USER_AGENT']), 0, 80);
      $addr_ip = substr (trim ($_SERVER['REMOTE_ADDR']), 0, 15);
      $db->sql_query ("UPDATE ".SN_TABLE_ADMINS." SET checknum = '".$checknum."', last_login = '".time ()."', last_ip = '".$addr_ip."', agent = '".$agent."'  WHERE admin_id='".$row['admin_id']."'");
      session_register ("admin_id");
      session_register ("admin_cn");
      $_SESSION['admin_cn'] =  base64_encode ("".$checknum."#:#".$agent."#:#".$addr_ip."");
      $_SESSION['admin_id'] = $row['admin_id'];
      $_SESSION['admin_name'] = $row['login'];
      $_SESSION['admin_fullname'] = $row['admin_fullname'];   }
   //redirect ('');
   header ('Location: admin.php');
   exit;
}

if (isset ($_GET['logout'])) {
   session_unset ();
   header ('Location: admin.php');
   exit;
}

if ((isset ($_SESSION['admin_id'])) AND (isset ($_SESSION['admin_cn']))) {
//   $conf['member_prefix'] = $conf['prefix'];
   include_once (SN_PathRootAdmin.'function.php');

   $cn_num = base64_decode ($_SESSION['admin_cn']);
   $ch_num = explode ("#:#", $cn_num);
   $sql = "SELECT * FROM ".SN_TABLE_ADMINS." WHERE admin_id = '".$_SESSION['admin_id']."' AND checknum = '".$ch_num[0]."' AND agent = '".$ch_num[1]."' AND last_ip = '".$ch_num[2]."'";
   $result = $db->sql_query ($sql);
   $row = $db->sql_fetchrow ($result);
   if ((!$row) OR ($ch_num[1] != substr (trim ($_SERVER['HTTP_USER_AGENT']), 0, 80))) {
      session_unset ();
      header ('Location: admin.php');
      exit;
   }

   if (isset ($_GET['in']) || isset ($_POST['in']) ) {
      $in = trim ((isset ($_POST['in']) ) ? $_POST['in'] : $_GET['in']);
   } else { $in = ''; }
   if (eregi ("[^a-zA-Z0-9_]", $in)) {
      header ('Location: admin.php');
      exit;
   }

   if (isset ($_GET['go']) || isset ($_POST['go']) ) {
      $go = trim ((isset ($_POST['go']) ) ? $_POST['go'] : $_GET['go']);
   } else { $go = ''; }
   if (eregi ("[^a-zA-Z0-9_]", $go)) {
      header ('Location: admin.php');
      exit;
   }

   if (isset ($_GET['grp']) || isset ($_POST['grp']) ) {
      $grp = trim ((isset ($_POST['grp']) ) ? $_POST['grp'] : $_GET['grp']);
   } else { $grp = 'module'; }
   if (eregi ("[^a-zA-Z0-9_]", $go)) {
      header ('Location: admin.php');
      exit;
   }

// для разрнаничения доступа админов по модулю
    $access_module = array_flip (explode ('|', $row['access']));
    if (($row['access'] == 'super') || ($row['access'] == 'full')) {
        $access = $row['access'];
    } elseif (isset ($access_module[$go])){
        $access = $go;
    } else {
        header ('Location: admin.php');
        exit;
    }
	
// для разрнаничения доступа админов по предмету
	if (($row['lesson'] == 'all') || ($row['lesson'] == 'super')) {$al = '';}
	else {
		  $lesson_mod = (explode ('|', $row['lesson']));
          $lesson = "";
		  $lcount = count($lesson_mod)-1;
		  
          for($i=0; $i<$lcount; $i++) {
            $lesson .= "'".$lesson_mod[$i].(($i<$lcount-1)? "', ": "'");
    		}
		  $al = " AND lesson IN (".$lesson.")";
}		
    if ($go == '') {
        define ('SN_ModuleName', '');
        define ('SN_ModulePath', SN_PathRoot.'home/'.SN_ModuleName.'/');
        define ('SN_ModulePathAdmin', SN_PathRootAdmin.'home/'.SN_ModuleName.'/');
        include (SN_PathRootAdmin.'home.php');
    } elseif (file_exists (SN_PathRootAdmin.'modules/'.$go.'.php')) {
         define ('SN_ModuleName', $go);
         define ('SN_ModulePath', SN_PathRoot.'modules/'.SN_ModuleName.'/');
         define ('SN_ModulePathAdmin', SN_PathRootAdmin.'modules/'.SN_ModuleName.'/');
         // Загрузка языка если есть
         if (file_exists (SN_PathRootAdmin.'lang/'.$go.'-'._SNSS_LANG.'.php')) {
            include_once (SN_PathRootAdmin.'lang/'.$go.'-'._SNSS_LANG.'.php');
         }
         // Подключение модуля
         include (SN_PathRootAdmin.'modules/'.SN_ModuleName.'.php');
         exit;
    } else {
        header ('Location: admin.php');
        exit;
    }

} else {
   session_unset ();
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<? echo _CHARSET; ?>">
<LINK REL="StyleSheet" HREF="files/style.css" TYPE="text/css">
<title><?php echo _ADMINAUTH; ?></title>
</head>
<body onload="javascript: document.admin_panel.admin_name.focus();">
<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
<tr>
<td align="center">
<form action="<?php echo url ('admin.php', true); ?>" method="post" name="admin_panel">
<table border="0" cellpadding="5" cellspacing="1" bgcolor="#EFEFEF">
<tr><td colspan="2"><b><?php echo _ADMINAUTH; ?></b></td></tr>
<tr bgcolor="#FFFFFF"><td><?php echo _ADMINLOGIN; ?>:</td><td><input type="text" name="admin_name" size="30" maxlength="25" style="width=150px"></td></tr>
<tr bgcolor="#FFFFFF"><td><?php echo _ADMINPASSWORD; ?>:</td><td><input type="password" name="admin_password" size="30" maxlength="255" style="width=150px"></td></tr>
<tr bgcolor="#FFFFFF"><td colspan="2">
<input type="submit" value="<?php echo _ENTERADMIN; ?>" style="width=100%" name="enter_admin"></td></tr></table>
</form><br><br><br>
</td>
</tr>
</table>
</body>
</html>
<?php
}
?>