<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: ru-dateformat.php
# Path: admin/files/help/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2005-2007 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: ru-dateformat.php
# Path: admin/files/help/
# Version: 2.0.4
######################################################################
if (!defined ('SN_SiteSystemAdmin')) { Header ('Location: ../../../index.php'); exit; }

?>
<p><b>Параметры формирования даты</b></p>
<table border="1">
  <thead>
    <tr>
      <th>Символ</th>
      <th>Описание</th>
      <th>Возвращаемое значение</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td align="center">d</td>
      <td>День месяца, 2 цифры с ведущими нулями</td>
      <td>от 01 до 31</td>
    </tr>
    <tr>
      <td align="center">D</td>
      <td>Сокращенное наименование дня недели, 2 символа</td>
      <td>от Вс до Сб</td>
    </tr>
    <tr>
      <td align="center">F</td>
      <td>Полное наименование месяца, например Январь</td>
      <td>от Январь до Декабрь</td>
    </tr>
    <tr>
      <td align="center">g</td>
      <td>Часы в 12-часовом формате без ведущих нулей</td>
      <td>От 1 до 12</td>
    </tr>
    <tr>
      <td align="center">G</td>
      <td>Часы в 24-часовом формате без ведущих нулей</td>
      <td>От 0 до 23</td>
    </tr>
    <tr>
      <td align="center">h</td>
      <td>Часы в 12-часовом формате с ведущими нулями</td>
      <td>От 01 до 12</td>
    </tr>
    <tr>
      <td align="center">H</td>
      <td>Часы в 24-часовом формате с ведущими нулями</td>
      <td>От 00 до 23</td>
    </tr>
    <tr>
      <td align="center">i</td>
      <td>Минуты с ведущими нулями</td>
      <td>От 00 до 59</td>
    </tr>
    <tr>
      <td align="center">j</td>
      <td>День месяца без ведущих нулей</td>
      <td>От 1 до 31</td>
    </tr>
    <tr>
      <td align="center">l</td>
      <td>Полное наименование дня недели</td>
      <td>От Воскресенье до Суббота</td>
    </tr>
    <tr>
      <td align="center">m</td>
      <td>Порядковый номер месяца с ведущими нулями</td>
      <td>От 01 до 12</td>
    </tr>
    <tr>
      <td align="center">M</td>
      <td>Сокращенное наименование месяца, 3 символа</td>
      <td>От Янв до Дек</td>
    </tr>
    <tr>
      <td align="center">n</td>
      <td>Порядковый номер месяца без ведущих нулей</td>
      <td>От 1 до 12</td>
    </tr>
    <tr>
      <td align="center">s</td>
      <td>Секунды с ведущими нулями</td>
      <td>От 00 до 59</td>
    </tr>
    <tr>
      <td align="center">w</td>
      <td>Порядковый номер дня недели</td>
      <td>От 0 (воскресенье) до 6 (суббота)</td>
    </tr>
    <tr>
      <td align="center">Y</td>
      <td>Порядковый номер года, 4 цифры</td>
      <td>Пример: 1999, 2003</td>
    </tr>
    <tr>
      <td align="center">y</td>
      <td>Номер года, 2 цифры</td>
      <td>Пример: 99, 03</td>
    </tr>
  </tbody>
</table>
<p>
<b>Пример</b><br />
Если Вам необходимо вывести дату следующего формата <font color="#0000FF">Воскресенье, 1 Мая 2005</font>,<br />
то в поле формы Вы вводите следующий параметр: <font color="#0000FF">l, j F Y </font><br /><br />
Более подробно о формировании даты функции date() можно узнать <a href="http://www.php.net/manual/ru/function.date.php" target="_blank">здесь</a>.<br />
</p>