<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: header.php
# Path: admin/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2005-2007 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: header.php
# Path: admin/
# Version: 2.0.4.RC1
######################################################################
if (!defined ('SN_SiteSystemAdmin')) { Header ('Location: ../index.php'); exit; }

global $conf, $access_module, $access, $header_page_title, $go;

echo '<html>'
    .'<head>'
    .'<META http-equiv="Content-Type" CONTENT="text/html; charset='._CHARSET.'">'
    .'<LINK REL="StyleSheet" HREF="files/style.css" TYPE="text/css">'
    .'<title>'.$conf['site_name'].' | '._SYSADMIN.' | '.$header_page_title.'</title>';

include (SN_PathRootAdmin.'files/java_scripts.js');

echo '</head>';
echo '<body  topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0">'
    .'<table border="0" cellpadding="0" cellspacing="0" width="100%">'
    .'<tr><td width="70%" background="files/images/h-h-bg.gif"><img border="0" src="" width="1" height="4"></td>'
    .'<td width="30%" background="files/images/h-h-bg.gif"><img border="0" src="" width="1" height="4"></td></tr>'
    .'<tr><td height="30" background="files/images/b-h-bg.gif"><b>'
    .'&nbsp;&nbsp;<a href="admin.php" class="header">'._ADMINHOME.'</a>'
    .'&nbsp;&nbsp;|&nbsp;&nbsp;<a href="../index.php" class="header" target="_blank">'._GOTOSITE.'</a>'
    .'&nbsp;&nbsp;|&nbsp;&nbsp;<a href="admin.php?logout" class="header">'._EXITADMIN.'</a>';

// Языковая составляющая
if ($conf['multi_lang'] == 1) {
    $handle = opendir (SN_PathRoot.'lang');
    echo '&nbsp;&nbsp;|';
    while (false !== ($file = readdir ($handle))) {
        $rowlang = substr ($file, 5, strlen ($file)-9);
        if ($file === ('lang-'.$rowlang.'.php')) {
            echo '&nbsp;<a href="admin.php?newlang='.$rowlang.'" class="header"><span style="text-transform: uppercase">'.$rowlang.'</span></a>';
        }
    }
    closedir ($handle);
    unset ($handle, $file, $rowlang);
}

echo '</b></td>';
echo '<td height="30" background="files/images/b-h-bg.gif" align="right">'
    .'<b><a href="http://www.schoolnuke.ru" class="header" target="_blank" title="School System - SchoolNuke">SchoolNuke v.'.$conf['version'].'</a></b>&nbsp;&nbsp;'
    .'</td></tr>'
    .'<tr><td background="files/images/f-h-bg.gif"><img border="0" src="" width="1" height="4"></td>'
    .'<td background="files/images/f-h-bg.gif"><img border="0" src="" width="1" height="4"></td></tr>'
    .'</table>';
echo '<table border="0" cellpadding="0" cellspacing="0" width="100%">'
    .'<tr><td valign="top">';

//Навигация админ панели
$menu = array();
$i = 1;
$handle = opendir (SN_PathRootAdmin.'links');
while (false !== ($file = readdir ($handle))) {
    $rowmenu = substr ($file, 6, strlen ($file)-13);
    if ($file === ('links.'.$rowmenu.'-'._SNSS_LANG.'.php') && ($access == 'super' || $access == 'full' || isset ($access_module[$rowmenu]))) {
		$menu[$i] = $rowmenu ;
        $i++; }
}
closedir ($handle);
if ($sizemenu = count($menu)) {
//$sizemenu = (count($menu) == 0)? 1: count($menu);
$denominator = 0;
do {
	$denominator++;
	$numerator = ceil($sizemenu/$denominator);
//$numerator =1;
} while ($numerator > ($denominator*9));
$width = floor(100/$numerator);
$i = 1;
for ($j = 1; $j <= $denominator; $j++) {
echo '<table width="100%" border="0" cellpadding="1" cellspacing="0" bgcolor="#d3d3d3"><tr>';
	while ($i <= ($j*$numerator)) {
	echo '<td width="'.$width.'%"><div id=b>';
	echo '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td>';
	if (isset($menu[$i])) {
		include (SN_PathRootAdmin.'links/links.'.$menu[$i].'-'._SNSS_LANG.'.php');}
	echo '</td></tr></table></div></td>';
	$i++; }
	echo '</tr></table>';
echo '</td></tr></table>'; } 
}
unset ($handle, $file, $rowmenu);
//Окончание навигации

echo '</td></tr></table>';
echo '<table border="0" cellpadding="5" cellspacing="5" width="100%">'
    .'<tr><td width="100%" valign="top">'
    .'<table width="100%" border="0" cellpadding="0" cellspacing="0">'
	.'<tr><td width=100%><b>'.$header_page_title.'</b></td>'
    ."<td><a title=\""._ADMINHELP."\" class=\"help\" href=\"javascript:;\" onClick=\"MM_openBrWindow('help.php?go=".SN_ModuleName."','','scrollbars=yes,width=400,height=500')\"><img border=\"0\" src=\"files/images/help.gif\" width=\"16\" height=\"16\"></a></td>"
	.'</tr></table><hr>';
?>
