<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: level
# File: edit.php
# Path: admin/modules/level/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
if (!defined ('SN_SiteSystemAdmin')) { Header ('Location: ../../index.php'); exit; }

$header_page_title = _ADMINLEVEL;

function save_edit () {
   global $eror_reg, $db, $conf, $al;
   
   if (isset ($_POST['cancel'])) { Header ("Location: ".url('')); exit; }

   $lesson = (isset ($_POST['lesson']))? trim(strip_tags ($_POST['lesson'])): '';
   if (!((strpos($al, "'".$lesson."'") && $al) || ($al === ""))) { Header ("Location: ".url('')); exit; }
   
   $level_id = (isset ($_POST['id']))? intval($_POST['id']): 0;
   $levels = (isset ($_POST['levels']))? intval($_POST['levels']): 0;
   $levelname = (isset ($_POST['levelname']))? trim(strip_tags($_POST['levelname'])): '';
   $id_table = (isset ($_POST['id_table']))? intval($_POST['id_table']): 0;
   $curriculum = (isset ($_POST['curriculum']))? intval($_POST['curriculum']): 0;
   $skriptname = (isset ($_POST['skriptname']))? trim(strip_tags($_POST['skriptname'])): '';
   $status = (isset ($_POST['status']))? trim (strip_tags($_POST['status'])): '';
   check_level ($levels, $levelname, $curriculum, $lesson, $skriptname, $level_id);

   $s_array = insearch ('&in=save_edit&id='.$level_id); 
   if (isset($eror_reg)) {

   $result_table = $db->sql_query ("SELECT * FROM ".SN_TABLE_TABLE." WHERE table_id > '0'".$al);
   $result_lesson = $db->sql_query ("SELECT * FROM ".SN_LESSON_TABLE." WHERE lesson_id > '0'".$al);
   if ((!$result_table) || (!$result_lesson)) { Header ("Location: ".url('')); exit; }

   include (SN_PathRootAdmin.'header.php');
   echo '<b><font color=FF9933>»</font>&nbsp;<a href="'.url ('').'">'._LEVELHOME.'</a></b><br /><br />';
   echo '<center><table width="80%" border="0" cellspacing="3" cellpadding="1" bgcolor="#EFEFEF">'
       .'<tr><th align="center">'._EROREDITLEVEL.'</th></tr>'
       .'<tr><td align="center" bgcolor="#FFFFFF"><br />'.$eror_reg.'<br />';
    if ($eror_reg == _LEVELSTAKEN) {
	   $row_max = $db->sql_fetchrow ($db->sql_query ("SELECT MAX(levels) FROM ".SN_LEVEL_TABLE." WHERE levels='".$levels."' AND curriculum='".$curriculum."' AND lesson='".$lesson."'"));
       $maxlevel = $row_max ['MAX(levels)'];
	   echo _NEWMAXREGEROR.' '.$maxlevel.'<br />'._SETUPLEVEL.'<br />';
	   $levels = $maxlevel + 1;
    }	   
   echo '<br /></td></tr></table></center><br />';

   echo '<center><form action="'.$s_array['form'].'" method="post" style="display: inline">'
       .'<table border="0" cellspacing="1" bgcolor="#EFEFEF" cellpadding="3">'
       .'<tr><td colspan=2><b>'._ADDNEWLEVEL.'</b></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LLEVELS.'</td>'
       .'<td bgcolor="#FFFFFF"><input type="text" name="levels" size="70" style="width=250px" value="'.$levels.'"></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LNAME.'</td>'
       .'<td bgcolor="#FFFFFF"><input type="text" name="levelname" size="70" style="width=250px" value="'.$levelname.'"></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LTABLE.'</td>'
       .'<td bgcolor="#FFFFFF"><select name="id_table" style="width=250px"><option value="" selected="selected"></option>';
   while ($row_table = $db->sql_fetchrow ($result_table)) {
      echo '<option value="'.$row_table['table_id'].'"'.(($id_table == $row_table['table_id']) ? ' selected="selected"': '').'>'.$row_table['tablefullname'].'</option>';
   }
   echo '</select></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LCURRICULUM.'</td>'
       .'<td bgcolor="#FFFFFF"><input type="text" name="curriculum" size="70" style="width=250px" value="'.$curriculum.'"></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LLESSON.'</td>'
       .'<td bgcolor="#FFFFFF"><select name="lesson" style="width=250px">';
   while ($listlesson = $db->sql_fetchrow ($result_lesson)) {
      echo '<option value="'.$listlesson['lesson'].'"'.(($lesson == $listlesson['lesson']) ? ' selected="selected"' : '').'>'.$listlesson['lessonname'].'</option>';
   }
   echo '</select></td></tr>';
   echo '<tr><td bgcolor="#FFFFFF">'._LSKRIPT.'<font color=red>*</font></td>' 
       .'<td bgcolor="#FFFFFF"><select name="skriptname" style="width=250px">';
$dir = SN_PathRoot.'modules/testing';
if (is_dir($dir)) {
    if ($blocksdir = opendir($dir)) {
     while (false !== ($file = readdir ($blocksdir))) {
	   echo ((!ereg ("[.]", $file)) && (!ereg ("[..]", $file)) && (!ereg ("lang", $file)))? '<option value="'.$file.'"'.(($file == $skriptname) ? ' selected="selected"': '').'>'.$file.'</option>': '';
	 }
     closedir ($blocksdir);
    }
} 	   
   echo '</select></td></tr>';   
   echo '<tr><td bgcolor="#FFFFFF">'._LSTATUS.'</td>'
       .'<td bgcolor="#FFFFFF"><select name="status" style="width=250px">';
   echo '<option value="active"'.(($status == "active") ? ' selected="selected"': '').'>'._LACTIV.'</option>';
   echo '<option value="inactive"'.(($status == "inactive") ? ' selected="selected"': '').'>'._LINACTIV.'</option>';   
   echo '</select></td></tr>';
   echo '<tr><td colspan="2" bgcolor="#FFFFFF">'
       .'<input type="hidden" name="go" value="level">'
       .'<input type="hidden" name="in" value="save_edit">'
	   .'<input type="hidden" name="id" value="'.$level_id.'">';
   echo $s_array['input'];
   echo '<input type="submit" value="'._SAVEEDIT.'">&nbsp; &nbsp;'
	   .'<input name="cancel" type="submit" value="'._CANSEL.'">'
       .'</td></tr>'
       .'<tr><td colspan="2" bgcolor="#FFFFFF">'
       .'<font color=red>*</font>'._LEARNING.'<br /><font color=red>*</font>'._TRENING.'<br /><font color=red>*</font>'._CHECKING
       .'</td></tr>'
       .'</table></form></center>';
   include (SN_PathRootAdmin.'footer.php');
   } else {
   if ($db->sql_query ("UPDATE ".SN_LEVEL_TABLE." SET levels='".$levels."', levelname='".$levelname."', id_table='".$id_table."', curriculum='".$curriculum."', lesson='".$lesson."', skriptname='".$skriptname."', status='".$status."'  WHERE level_id='".$level_id."'")) { redirect ($s_array['result']); } else { redirect ('&in=error'); }
   }
}

function edit () {
   global $db, $conf, $al;

   $level_id = (isset ($_GET['id']))? intval ($_GET['id']) : 0;
   $result_table = $db->sql_query ("SELECT * FROM ".SN_TABLE_TABLE." WHERE table_id > '0'".$al);
   $result_lesson = $db->sql_query ("SELECT * FROM ".SN_LESSON_TABLE." WHERE lesson_id > '0'".$al);
   if ((!$result_table) || (!$result_lesson)) { Header ("Location: ".url('')); exit; }
   
   if (!$row = $db->sql_fetchrow ($db->sql_query ("SELECT * FROM ".SN_LEVEL_TABLE." WHERE level_id = '".$level_id."'"))) { Header ("Location: ".url('')); exit; }

   $s_array = insearch ('&in=save_edit&id='.$level_id);   
   include (SN_PathRootAdmin.'header.php');   
   echo '<b><font color=FF9933>»</font>&nbsp;<a href="'.url ('').'".>'._LEVELHOME.'</a></b><br /><br />';
   echo '<center><form action="'.$s_array['form'].'" method="post" style="display: inline">'
       .'<table border="0" cellspacing="1" bgcolor="#EFEFEF" cellpadding="3">'
       .'<tr><td colspan=2><b>'._EDITLEVEL.'</b></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LLEVELS.'</td>'
       .'<td bgcolor="#FFFFFF"><input type="text" name="levels" size="70" style="width=250px" value="'.$row['levels'].'"></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LNAME.'</td>'
       .'<td bgcolor="#FFFFFF"><input type="text" name="levelname" size="70" style="width=250px" value="'.$row['levelname'].'"></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LTABLE.'</td>'
       .'<td bgcolor="#FFFFFF"><select name="id_table" style="width=250px">';
   while ($row_table = $db->sql_fetchrow ($result_table)) {
      echo '<option value="'.$row_table['table_id'].'"'.(($row['id_table'] == $row_table['table_id']) ? ' selected="selected"': '').'>'.$row_table['tablefullname'].'</option>';
   }
   echo '</select></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LCURRICULUM.'</td>'
       .'<td bgcolor="#FFFFFF"><input type="text" name="curriculum" size="70" style="width=250px" value="'.$row['curriculum'].'"></td></tr>'
       .'<tr><td bgcolor="#FFFFFF">'._LLESSON.'</td>'
       .'<td bgcolor="#FFFFFF"><select name="lesson" style="width=250px">';
   while ($listlesson = $db->sql_fetchrow ($result_lesson)) {
      echo '<option value="'.$listlesson['lesson'].'"'.(($row['lesson'] == $listlesson['lesson']) ? ' selected="selected"' : '').'>'.$listlesson['lessonname'].'</option>';
   }
   echo '</select></td></tr>';
   echo '<tr><td bgcolor="#FFFFFF">'._LSKRIPT.'<font color=red>*</font></td>' 
       .'<td bgcolor="#FFFFFF"><select name="skriptname" style="width=250px">';
$dir = SN_PathRoot.'modules/testing';
if (is_dir($dir)) {
    if ($blocksdir = opendir($dir)) {
     while (false !== ($file = readdir ($blocksdir))) {
	   echo ((!ereg ("[.]", $file)) && (!ereg ("[..]", $file)) && (!ereg ("lang", $file)))? '<option value="'.$file.'"'.(($file == $row['skriptname']) ? ' selected="selected"': '').'>'.$file.'</option>': '';
	 }
     closedir ($blocksdir);
    }
} 	   
   echo '</select></td></tr>';
   echo '<tr><td bgcolor="#FFFFFF">'._LSTATUS.'</td>'
       .'<td bgcolor="#FFFFFF"><select name="status" style="width=250px">';
   echo '<option value="active"'.(($row['status'] == "active") ? ' selected="selected"': '').'>'._LACTIV.'</option>';
   echo '<option value="inactive"'.(($row['status'] == "inactive") ? ' selected="selected"': '').'>'._LINACTIV.'</option>';   
   echo '</select></td></tr>'
       .'<tr><td colspan="2" bgcolor="#FFFFFF">'
       .'<input type="hidden" name="id" value="'.$level_id.'">'
       .'<input type="hidden" name="go" value="level">'
       .'<input type="hidden" name="in" value="save_edit">';
  echo $s_array['input'];
  echo '<input type="submit" name="enter" value="'._SAVEEDIT.'">&nbsp; &nbsp;'
	   .'<input name="cancel" type="submit" value="'._CANSEL.'">'
       .'</td></tr>'
       .'<tr><td colspan="2" bgcolor="#FFFFFF">'
       .'<font color=red>*</font>'._LEARNING.'<br /><font color=red>*</font>'._TRENING.'<br /><font color=red>*</font>'._CHECKING
       .'</td></tr>'
       .'</table></form></center>';
   include (SN_PathRootAdmin.'footer.php');
}
?>