<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: setting.php
# Path: admin/modules/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: setting.php
# Path: admin/modules/
# Version: 2.0.4
######################################################################
if (!defined ('SN_SiteSystemAdmin')) { Header ('Location: ../../index.php'); exit; }

$header_page_title = _SITECONFIG;

function main_setting () {
   global $conf, $access;

   $lang['tz']['-12'] = 'GMT - 12';
   $lang['tz']['-11'] = 'GMT - 11';
   $lang['tz']['-10'] = 'GMT - 10';
   $lang['tz']['-9'] = 'GMT - 9';
   $lang['tz']['-8'] = 'GMT - 8';
   $lang['tz']['-7'] = 'GMT - 7';
   $lang['tz']['-6'] = 'GMT - 6';
   $lang['tz']['-5'] = 'GMT - 5';
   $lang['tz']['-4'] = 'GMT - 4';
   $lang['tz']['-3.5'] = 'GMT - 3:30';
   $lang['tz']['-3'] = 'GMT - 3';
   $lang['tz']['-2'] = 'GMT - 2';
   $lang['tz']['-1'] = 'GMT - 1';
   $lang['tz']['0'] = 'GMT '._GRINVID.'';
   $lang['tz']['1'] = 'GMT + 1';
   $lang['tz']['2'] = 'GMT + 2';
   $lang['tz']['3'] = 'GMT + 3 '._MOSCOWTIME.'';
   $lang['tz']['3.5'] = 'GMT + 3:30';
   $lang['tz']['4'] = 'GMT + 4 '._SUMMOSCTIME.'';
   $lang['tz']['4.5'] = 'GMT + 4:30';
   $lang['tz']['5'] = 'GMT + 5';
   $lang['tz']['5.5'] = 'GMT + 5:30';
   $lang['tz']['6'] = 'GMT + 6';
   $lang['tz']['6.5'] = 'GMT + 6:30';
   $lang['tz']['7'] = 'GMT + 7';
   $lang['tz']['8'] = 'GMT + 8';
   $lang['tz']['9'] = 'GMT + 9';
   $lang['tz']['9.5'] = 'GMT + 9:30';
   $lang['tz']['10'] = 'GMT + 10';
   $lang['tz']['11'] = 'GMT + 11';
   $lang['tz']['12'] = 'GMT + 12';
   $lang['tz']['13'] = 'GMT + 13';

   $cookie_hour = $conf['live_cookie_time']/3600;

   if (!($conf = load_config ('', 'system'))) {
      //include (SN_PathRootAdmin.'header.php');
      //echo '<br /><br /><b>ОШИБКА!</b><br /><br />Не удалось произвести чтение данных из конфигурационного файла!";
      //      echo '<br /><br /><b>'._ERORSAVE.'</b><br /><br />'._ERORSAVETEXT."";
      //include (SN_PathRootAdmin.'footer.php');
      //exit;
      $conf = load_ini ('DefaultConfig');
   }

   include (SN_PathRootAdmin.'header.php');

   echo '<center>'
       .'<form enctype="multipart/form-data" action="'.url ('&in=save_setting').'" method="post" style="display: inline">'
       .'<table border="0" cellspacing="1" bgcolor="#EFEFEF" cellpadding="3">';
// Общие настройки сайта
// if ($access == 'super') {
   echo '<tr><td colspan=2><b>'._ALLCONFIG.'</b></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._SITEURL.'</td>'
       .'<td><input type="text" name="config[xsite_url]" size="70" style="width=250px" value='.$conf['site_url'].'></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._SITEPATH.'</td>'
       .'<td><input type="text" name="config[xsite_path]" size="70" style="width=250px" value='.$conf['site_path'].'></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._ADMINPATH.'</td>'
       .'<td><input type="text" name="config[xadmin_path]" size="70" style="width=250px" value='.$conf['admin_path'].'></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._SITENAME.'</td>'
       .'<td><input type="text" name="config[xsite_name]" size="70" style="width=250px" value='.$conf['site_name'].'></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._SITEDESCR.'</td>'
       .'<td><textarea name="config[xsite_description]" cols="70" rows="3" style="width=250px">'.$conf['site_description'].'</textarea></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._SITEKEYWORDS.'</td>'
       .'<td><textarea name="config[xsite_keywords]" cols="70" rows="3" style="width=250px">'.$conf['site_keywords'].'</textarea></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._ADMINMAIL.'</td>'
       .'<td><input type="text" name="config[xadmin_mail]" size="70" style="width=250px" value='.$conf['admin_mail'].'></td></tr>';
// }
// Технические настройки сайта
//if ($access == 'super') {
   echo '<tr><td colspan=2><b>'._TEHNICSETTING.'</b></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._DEFAULTDESIGN.'</td>'
       .'<td><select name="config[xdefault_design]" style="width=250px">';
   $themelist = '';
   $handle = opendir (SN_PathRoot.'template');
   while (false !== ($file = readdir ($handle))) {
      if (!ereg ("[.]", $file)) {
         $themelist .= $file." ";        
      }
   }
   closedir ($handle);
   $themelist = explode (" ", $themelist);
   sort ($themelist);
   for ($i=0; $i<sizeof ($themelist); $i++) {
      if ($themelist[$i]!="") {
        echo '<option value="'.$themelist[$i].'"'.(($themelist[$i] == $conf['default_design']) ? ' selected="selected"': '').'>'.$themelist[$i].'</option>';
      }
   }
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._HOMEMODULE.'</td>'
       .'<td><select name="config[xdefault_module]" style="width=250px">';
   $modlist = "";
   $handle = opendir (SN_PathRoot.'modules');
   while (false !== ($file = readdir ($handle))) {
      if (!ereg ("[.]",$file)) {
         $modlist .= $file.' ';
      }
   }
   closedir ($handle);
   $modlist = explode (" ", $modlist);
   sort ($modlist);
   for ($i=0; $i<sizeof ($modlist); $i++) {
      if ($modlist[$i]!="") {
        echo '<option value="'.$modlist[$i].'"'.(($modlist[$i] == $conf['default_module']) ? ' selected="selected"': '').'>'.$modlist[$i].'</option>';
      }
   }
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._REDACTOR.'</td>'
       .'<td><select name="config[xallow_redaktor]" style="width=250px">';
   echo '<option value="1"'.(($conf['allow_redaktor'] == 1) ? ' selected="selected"': '').'>'._ALLOW.'</option>';
   echo '<option value="0"'.(($conf['allow_redaktor'] == 0) ? ' selected="selected"': '').'>'._DISSALOW.'</option>';
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._SITETIME.'</td>'
       .'<td><select name="config[xtime_zone]" style="width=250px">';
   while (list ($offset, $zone) = @each ($lang['tz'])) {
   echo '<option value="'.$offset.'"'.(($offset == $conf['time_zone']) ? ' selected="selected"': '').'>'.$zone.'</option>';
   }
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._DEFAULTLANG.'</td>'
       .'<td><select name="config[xdefault_lang]" style="width=250px">';
    $handle = opendir (SN_PathRoot.'lang');
    while (false !== ($file = readdir ($handle))) {
        $rowlang = substr ($file, 5, strlen ($file)-9);
        if ($file === ('lang-'.$rowlang.'.php')) {
         echo '<option  value="'.$rowlang.'"'.(($rowlang == $conf['default_lang'])? ' selected="selected"': '').'>'.ucfirst ($rowlang).'</option>';
        }
    }
    closedir ($handle);
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._MULTILANG.'</td>'
       .'<td><select name="config[xmulti_lang]" style="width=250px">';
   echo '<option value="1"'.(($conf['multi_lang'] == 1) ? ' selected="selected"': '').'>'._ALLOW.'</option>';
   echo '<option value="0"'.(($conf['multi_lang'] == 0) ? ' selected="selected"': '').'>'._DISSALOW.'</option>';
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._GZIPMETHOD.'</td>'
   .'<td><select name="config[xgzip_method]" style="width=250px">';
   echo '<option value="1"'.(($conf['gzip_method'] == 1) ? ' selected="selected"': '').'>'._ALLOW.'</option>';
   echo '<option value="0"'.(($conf['gzip_method'] == 0) ? ' selected="selected"': '').'>'._DISSALOW.'</option>';
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._ERORREPORT.'</td>'
       .'<td><select name="config[xeror_value]" style="width=250px">';
   echo '<option value="2047"'.(($conf['eror_value'] == 2047) ? ' selected="selected"': '').'>'._PRINTDISPLAY.'</option>';
   echo '<option value="0"'.(($conf['eror_value'] == 0) ? ' selected="selected"': '').'>'._NOPRINTDISPLAY.'</option>';
   echo '</select></td></tr>';
// Пользователи и регистрация
//if ($access == 'super') {
   echo '<tr><td colspan=2><b>'._USERANDREG.'</b></td></tr>';
//   echo '<tr bgcolor="#FFFFFF"><td>'._REGISTRATION.'</td>'
//       .'<td><select name="config[xregister_user]" style="width=250px">';
//   echo '<option value="1"'.(($conf['register_user'] == 1) ? ' selected="selected"': '').'>'._ALLOW.'</option>';
//   echo '<option value="0"'.(($conf['register_user'] == 0) ? ' selected="selected"': '').'>'._DISSALOW.'</option>';
//   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._REGMETHOD.'</td>'
       .'<td><select name="config[xreg_user_method]" style="width=250px">';
   echo '<option value="1"'.(($conf['reg_user_method'] == 1) ? ' selected="selected"': '').'>'._NOMAILCHECK.'</option>';
   echo '<option value="2"'.(($conf['reg_user_method'] == 2) ? ' selected="selected"': '').'>'._MAILCHECK.'</option>';
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._AUTHMETHOD.'</td>'
       .'<td><select name="config[xallow_cookie]" style="width=250px">';
   echo '<option value="1"'.(($conf['allow_cookie'] == 1) ? ' selected="selected"': '').'>'._SESANDCOOKIE.'</option>';
   echo '<option value="0"'.(($conf['allow_cookie'] == 0) ? ' selected="selected"': '').'>'._ONLYSESSION.'</option>';
   echo '</select></td></tr>';
   echo '<tr bgcolor="#FFFFFF"><td>'._COOKIEPREFIX.'</td>'
       .'<td><input type="text" name="config[xcookie_prefix]" size="70" style="width=250px" value='.$conf['cookie_prefix'].'></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._COOKIEPATH.'</td>'
       .'<td><input type="text" name="config[xcookie_path]" size="70" style="width=250px" value='.$conf['cookie_path'].'></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._COOKIEDOMAIN.'</td>'
       .'<td><input type="text" name="config[xcookie_domain]" size="70" style="width=250px" value='.$conf['cookie_domain'].'></td></tr>'
       .'<tr bgcolor="#FFFFFF"><td>'._COOKIETIME.'</td>'
       .'<td><table border="0" cellpadding="0" cellspacing="0" width="100%">'
       .'<tr><td width="50%">'
       .'<input type="text" name="config[xlive_cookie_time]" size="70" style="width=100%" value='.$cookie_hour.'></td>'
       .'<td>&nbsp;</td>'
       .'<td width="50%"><select name="config[xlive_cookie_sec]" style="width=100%">'
       .'<option value=3600 selected>'._HOURS.'</option>'
       .'<option value=86400>'._DAYS.'</option>'
       .'</select></td></tr></table></td></tr>';
   echo '<tr><td bgcolor="#FFFFFF" colspan=2>'
       .'<input type="hidden" name="go" value="setting">'
       .'<input type="hidden" name="in" value="save_setting">'
       .'<input name="enter" type="submit" value="'._SAVESETTING.'">&nbsp; &nbsp;'
  	   .'<input name="cancel" type="submit" value="'._CANSEL.'">'
       .'</table></form>';
   echo '</center>';
   include (SN_PathRootAdmin.'footer.php');
}

function save_setting () {
    global $conf, $db, $db_conf;

   if (isset ($_POST['cancel'])) { Header ("Location: ".url('')); exit; }
	
    if (!($conf_sys = load_config ('', 'system'))) {
        include (SN_PathRootAdmin.'header.php');
        echo '<br /><br /><b>ОШИБКА!</b><br /><br />Не удалось произвести чтение данных из конфигурационного файла!';
        //      echo '<br /><br /><b>'._ERORSAVE.'</b><br /><br />'._ERORSAVETEXT."";
        include (SN_PathRootAdmin.'footer.php');
        exit;
    }
    $conf_sys = array_merge (load_ini ('DefaultConfig'), $conf_sys);

    // Очистка от слешей
    $config = (is_array ($_POST['config'])) ? array_map ('stripslashes', $_POST['config']) : array ();
    $xsite_url = (isset ($config['xsite_url']))? trim ($config['xsite_url']) : $conf_sys['site_url'];
    $xsite_url = preg_replace('/(^\W+)|(\W+$)/', '', $xsite_url);	
    $xsite_url = (!eregi('http://', $xsite_url))? 'http://'.$xsite_url : $xsite_url;

    $xsite_path = (isset ($config['xsite_path']))? trim ($config['xsite_path']) : $conf_sys['site_path'];
    $xsite_path = preg_replace('/(^\W+)|(\W+$)/', '', $xsite_path);
    $xsite_path = ($xsite_path != '')? '/'.$xsite_path.'/' : '/';	

    $xadmin_path = (isset ($config['xadmin_path']))? trim ($config['xadmin_path']) : $conf_sys['admin_path'];
    $xadmin_path = preg_replace('/(^\W+)|(\W+$)/', '', $xadmin_path);
	
    $conf_sys['site_name'] = (isset ($config['xsite_url']))? str_replace ('"','"', trim ($config['xsite_name'])) : $conf_sys['site_name'];//
    $conf_sys['site_description'] = (isset ($config['xsite_description']))? str_replace ('"','"', stripslashes ($config['xsite_description'])) : $conf_sys['site_description'];//
    $conf_sys['site_keywords'] = (isset ($config['xsite_keywords']))? str_replace ('"','"', trim ($config['xsite_keywords'])) : $conf_sys['site_keywords'];//
    $conf_sys['site_url'] = $xsite_url;//
    $conf_sys['site_port'] = $conf['site_port'];//
    $conf_sys['site_path'] = $xsite_path;//
	$conf_sys['admin_path'] = $xadmin_path;//
    $conf_sys['admin_mail'] = (isset ($config['xadmin_mail']))? trim ($config['xadmin_mail']) : $conf_sys['admin_mail'];//
    $conf_sys['default_design'] = (isset ($config['xdefault_design']))? trim ($config['xdefault_design']) : $conf_sys['default_design'];//
    $conf_sys['default_module'] = (isset ($config['xdefault_module']))? trim ($config['xdefault_module']) : $conf_sys['default_module'];//
    $conf_sys['allow_redaktor'] = (isset ($config['xallow_redaktor']))? intval ($config['xallow_redaktor']) : $conf_sys['allow_redaktor'];//
    $conf_sys['time_zone'] = (isset ($config['xtime_zone']))? intval ($config['xtime_zone']) : $conf_sys['time_zone'];//
    $conf_sys['default_lang'] = (isset ($config['xdefault_lang']))? trim ($config['xdefault_lang']) : $conf_sys['default_lang'];//
    $conf_sys['multi_lang'] = (isset ($config['xmulti_lang']))? intval ($config['xmulti_lang']) : $conf_sys['multi_lang'];//
    $conf_sys['gzip_method'] = (isset ($config['xgzip_method']))? intval ($config['xgzip_method']) : $conf_sys['gzip_method'];//
    $conf_sys['eror_value'] = (isset ($config['xeror_value']))? intval ($config['xeror_value']) : $conf_sys['eror_value'];//
//    $conf_sys['register_user'] = (isset ($config['xregister_user']))? intval ($config['xregister_user']) : $conf_sys['register_user'];//
    $conf_sys['reg_user_method'] = (isset ($config['xreg_user_method']))? intval ($config['xreg_user_method']) : $conf_sys['reg_user_method'];//
    $conf_sys['allow_cookie'] = (isset ($config['xallow_cookie']))? intval ($config['xallow_cookie']) : $conf_sys['allow_cookie'];//
    $conf_sys['cookie_path'] = (isset ($config['xcookie_path']))? trim ($config['xcookie_path']) : $conf_sys['cookie_path'];//
    $conf_sys['cookie_prefix'] = (isset ($config['xcookie_prefix']))? trim ($config['xcookie_prefix']) : $conf_sys['cookie_prefix'];//
    $conf_sys['cookie_domain'] = (isset ($config['xcookie_domain']))? trim ($config['xcookie_domain']) : $conf_sys['cookie_domain'];//
    $conf_sys['live_cookie_time'] = (isset ($config['xlive_cookie_sec']) && isset ($config['xlive_cookie_time']))? intval ($config['xlive_cookie_sec'])*intval ($config['xlive_cookie_time']) : $conf_sys['live_cookie_time'];//
    // Для совместимости
    $conf_sys['dbtype'] = $db_conf['dbtype'];
    $conf_sys['dbhost'] = $db_conf['dbhost'];
    $conf_sys['dbname'] = $db_conf['dbname'];
    $conf_sys['dbuname'] = $db_conf['dbuname'];
    $conf_sys['dbpass'] = $db_conf['dbpass'];
    $conf_sys['prefix'] = $db_conf['prefix'];
    $conf_sys['version'] = $db_conf['version'];
//    $conf_sys['Admin'] = $db_conf['Admin'];
	
    if (!save_config ($conf_sys, '', 'system')) {
        include (SN_PathRootAdmin.'header.php');
        echo '<br /><br /><b>ОШИБКА!</b><br /><br />Не удалось произвести запись данных в конфигурационный файл!';
        //      echo '<br /><br /><b>'._ERORSAVE.'</b><br /><br />'._ERORSAVETEXT."";
        include (SN_PathRootAdmin.'footer.php');
        exit;
    }

    $db->sql_query ("UPDATE ".$conf['prefix']."_modules SET status = '1'  WHERE title = '".$config['xdefault_module']."'");
    redirect ('');
}

switch ($in) {

    case "save_setting":
    save_setting ();
    break;

    default:
    main_setting ();
    break;
}
?>