<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: table
# File: base.php
# Path: admin/modules/table/default/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################

if (!defined ('SN_SiteSystemAdmin')) { Header ('Location: ../../../index.php'); exit; }

   $sqlnew['test'] = "CREATE TABLE IF NOT EXISTS `".$tables."_test` (`test_id` int(11) NOT NULL auto_increment, `tip` int(1) NOT NULL, `question` longtext, `complex` varchar(1) NOT NULL, `term` int(1) NOT NULL, `next` varchar(5) NOT NULL, `time` int(4) NOT NULL, `theory` longtext, UNIQUE KEY `test_id` (`test_id`)) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";

   $sqlnew['task'] = "CREATE TABLE IF NOT EXISTS `".$tables."_task` (`task_id` int(11) NOT NULL auto_increment, `id_test` int(11) NOT NULL, `correct` longtext, `addbool` varchar(100) NOT NULL, UNIQUE KEY `task_id` (`task_id`), KEY `id_test` (`id_test`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";

   $sqlnew['answer'] = "CREATE TABLE IF NOT EXISTS `".$tables."_answer` (`answer_id` int(11) NOT NULL auto_increment, `id_task` int(11) NOT NULL, `answer` longtext, `bool` int(5) NOT NULL default '0', UNIQUE KEY `answer_id` (`answer_id`), KEY `id_task` (`id_task`)) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";

   $sqlnew['log'] = "CREATE TABLE IF NOT EXISTS `".$tables."_log` (`id_log` int(10) NOT NULL auto_increment, `id_user` int(11) NOT NULL, `levels` int(5) NOT NULL, `journal` int(11) NOT NULL, `job` int(11) NOT NULL, `attempt` int(1) default '0', `pieces` longtext NOT NULL, `offer` longtext, `answer` longtext, `rating` int(1) default '0', `new_rating` float default '0', `max_rating` float default '0', PRIMARY KEY  (`id_log`), KEY `name_user` (`id_user`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";

?>