<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: bloks.php
# Path: inc/
# Version: 2.0.4
######################################################################
if ((!defined('SN_SiteSystem')) AND (!defined('SN_SiteSystemAdmin'))) { Header('Location: ../index.php'); exit; }
//if (!defined ('SN_SiteSystem')) { Header ('Location: ../index.php'); exit; }

// Инициализация масива блоков
$blocks = array();
$sql = "SELECT * FROM ".SN_TABLE_BLOCKS." WHERE status='1'";
$sql .= ($conf['multi_lang'] == 1) ? " AND ((language = '"._SNSS_LANG."') OR (language = ''))" : '' ;
$sql .= (_SNSS_HOME == '1') ?  " AND ((in_module = 'homeb') OR (in_module = '".$module['name']."') OR (in_module = 'all')) AND (no_module != 'homeb')" : " AND ((in_module = '".$module['name']."') OR (in_module = 'all')) AND ((no_module != '".$module['name']."') OR (no_module = 'all'))" ;
if ($conf['register_user'] == 1) { $sql .= ($user['member_id'] > 0) ? " AND ((view = '0') OR (view = '1'))" : " AND ((view = '0') OR (view = '2'))" ; }
$sql .= " ORDER BY weight";
$result = $db->sql_query ($sql);
while ($row = $db->sql_fetchrow ($result)) {
   $blocks[] = $row;
   }

// Функции работы с блоками
function block ($position) {
   global $conf, $template, $db, $user, $blocks;

   if (is_array ($blocks)) {
      reset ($blocks);
      foreach ($blocks as $block) {
         if ($block['position'] == $position) {
            if ($block['file_name'] != "") {
            block_fileinc ($block['block_id'], $block['title_'._SNSS_LANG], $block['file_name'], $position);
            } else {
               $template->set_filenames (array(
                  "".$position."_blocks_".$block['block_id']."" => "blocks/".$position."_blocks.tpl"
                  ));
               $template->assign_vars (array(
                  "BLOCK_TITLE" => $block['title_'._SNSS_LANG],
                  "BLOCK_CONTENT" => $block['text']
                  ));
               $template->pparse ("".$position."_blocks_".$block['block_id']."");
               $template->destroy ();
               }
            }
         }
      }
}

function block_fileinc ($block_id, $title, $file_name, $position) {
    global $template, $conf;
    $file = @file (SN_PathRoot.'blocks/'.$file_name);
    if (!$file) {
        $content = _NOFILEBLOCK;
    } else {
        include (SN_PathRoot.'blocks/'.$file_name);
    }
    if ($content == "") {
        $content = _NOBLOCKCONTENT;
    }
    $block_file_name = explode(".", $file_name);
    if (file_exists (SN_PathRoot.'template/'.$conf['default_design'].'/blocks/'.$block_file_name[0].'.tpl')) {
    $tpl_file = "".$block_file_name[0].".tpl";
    } else {
    $tpl_file = "".$position."_blocks.tpl";
    }

    $template->set_filenames (array(
        "".$position."_blocks_".$block_id."" => "blocks/$tpl_file")
    );
    $template->assign_vars (array(
        "BLOCK_TITLE" => $title,
        "BLOCK_CONTENT" => $content)
    );
    $template->pparse ("".$position."_blocks_".$block_id."");
    $template->destroy ();
}
// Конец функций
?>