<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: constants.php
# Path: inc/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: constants.php
# Path: inc/
# Version: 2.0.4
######################################################################

if ((!defined ('SN_SiteSystem')) AND (!defined ('SN_SiteSystemAdmin'))) { Header ('Location: ../index.php'); exit; }

// Константы блоков
define ('SN_BLOCK_NO', 0);
define ('SN_BLOCK_HEADER', 1);
define ('SN_BLOCK_LEFT', 2);
define ('SN_BLOCK_TOP', 4);
define ('SN_BLOCK_BOTTOM', 8);
define ('SN_BLOCK_RIGHT', 16);
define ('SN_BLOCK_FOOTER', 32);

// Users
define ('SN_ANONYMOUS', -1);

// SQL Таблицы
define ('SN_SESSIONS_TABLE', $db_conf['prefix'].'_sessions');
define ('SN_TABLE_BLOCKS', $db_conf['prefix'].'_blocks');
define ('SN_TABLE_MODULES', $db_conf['prefix'].'_modules');
define ('SN_MEMBERS_TABLE', $db_conf['prefix'].'_members');
define ('SN_LESSON_TABLE', $db_conf['prefix'].'_lesson');
define ('SN_GROUP_TABLE', $db_conf['prefix'].'_group');
define ('SN_TABLE_ADMINS', $db_conf['prefix'].'_admins');
define ('SN_TABLE_TABLE', $db_conf['prefix'].'_table');
define ('SN_LEVEL_TABLE', $db_conf['prefix'].'_level');
define ('SN_ALLOW_TABLE', $db_conf['prefix'].'_allow');
define ('SN_JOURNAL_TABLE', $db_conf['prefix'].'_journal');
define ('SN_ABOUT_TABLE', $db_conf['prefix'].'_mod_about');


// SQL коды
define ('BEGIN_TRANSACTION', 1);
define ('END_TRANSACTION', 2);

?>
