<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# This program is free software. You can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
######################################################################
# File: php.ini.php
# Path: install/
# Version: 2.0.4
######################################################################
# ЗАМЕНА .htaccess - все тоже самое можно написать
# - в .htaccess
# - в httpd.conf
# - в php.ini
#
# Если возникают проблема (появляются ошибки, ссылающиеся на этот файл,
# то попробуйте перенести проблеммные параметры в указанные выше 3 файла.
######################################################################
if ((!defined('SN_SiteSystem')) AND (!defined('SN_SiteSystemAdmin'))) { Header('Location: ../index.php'); exit; }

# Уровень сообщений об ошибках.
# Под тестированием и работой понимается пуско/наладочная деятельность
# и рабочий режим (когда его ковыряют посетители).
ini_set ('display_errors', 1); // при тестировани - 1, при работе - 0
ini_set ('display_startup_errors', 1); // при тестировани - 1, при работе - 0
ini_set ('log_errors', 1); // всегда 1. Читайте логи Апача, там будут копиться ПХП-ошибки!!!
ini_set ('error_reporting', 2047); // при тестировании - 2047, при работе - 2039
ini_set ('track_errors', 1); // Сохранять ли последнее сообщение об ошибке или предупреждение в переменной $php_errormsg

# отключить магик квоты
//set_magic_quotes_runtime (0);
ini_set ('magic_quotes_runtime', 'Off');
ini_set ('magic_quotes_sybase', 'Off');

// Работа с сессиями
//ini_set ('url_rewriter.tags', 'sn'); // это можно стереть, если тут происходит ошибка
ini_set ('session.auto_start', '0'); // автостарт сессий не нужен
ini_set ('session.use_trans_sid', '0'); // отключить авто вставку номера сессии (SID)
ini_set ('session.use_cookies', '1'); // Использовать куки
ini_set ('session.name', 'SNS'); // имя сессионной переменной
ini_set ('session.cookie_lifetime', '0'); // 0 - кука умирает при закрытии браузера
ini_set ('session.gc_maxlifetime', '1800'); // время жизни сессии, полчаса
ini_set ('session.gc_divisor', '100'); // Управление созданием сессий
ini_set ('session.gc_probability', '15') // Управление созданием сессий
?>