<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: index.php
# Path: /
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2005-2007 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Core
# File: index.php
# Path: /
# Version: 2.0.4
######################################################################
function get_microtime () {
    list ($usec, $sec) = explode (" ", microtime());
    return ($usec + $sec);
}
$start_time = get_microtime ();
$start_memory = 0;
if (function_exists ('memory_get_usage')) { $start_memory = memory_get_usage (); }
/* else if ( strpos( strtolower($_SERVER['SERVER_SOFTWARE']), 'win') !== false) {
   // Windows workaround
   $output = array();
   exec('tasklist /FI "PID eq ' . getmypid() . '" /FO LIST', $output);
   $start_memory = str_replace(".", '', substr($output[5], strpos($output[5], ':') + 1, -2))*1024;
} */


define ('SN_SiteSystem', true);
define ('SN_PathRoot', realpath (dirname (__FILE__).'/').'/');
include (SN_PathRoot.'inc/common.php');

if (file_exists (SN_PathRoot.'lang/lang-'._SNSS_LANG.'.php')) {
   include_once (SN_PathRoot.'lang/lang-'._SNSS_LANG.'.php');
} else {
   eror ("Eror! Lang file is absent");
   exit;
}

if (isset ($_GET['file']) || isset ($_POST['file']) ) {
   $file = trim (( isset($_POST['file']) ) ? $_POST['file'] : $_GET['file']);
   if (eregi ("[^a-zA-Z0-9_]",$file)) { define ('_SNSS_HOME', '0'); define ('_SNSS_THEME','0'); $module['name'] = 'home'; include (SN_PathRoot.'inc/blocks.php'); eror(_ERORHAK); exit; }
   } else { $file = 'index'; }

if (isset ($_GET['go']) || isset ($_POST['go']) ) {
    $go = trim (( isset($_POST['go']) ) ? $_POST['go'] : $_GET['go']);
    if (eregi ("[^a-zA-Z0-9_]",$go)) { define ('_SNSS_HOME', '0'); define ('_SNSS_THEME','0'); $module['name'] = 'home'; include (SN_PathRoot.'inc/blocks.php'); eror(_ERORHAK); exit; }
    } else { $go = ''; }

if (isset ($_GET['in']) || isset ($_POST['in']) ) {
    $in = trim (( isset($_POST['in']) ) ? $_POST['in'] : $_GET['in']);
    if (eregi ("[^a-zA-Z0-9_]",$in)) { define ('_SNSS_HOME', '0'); define ('_SNSS_THEME','0'); $module['name'] = 'home'; include (SN_PathRoot.'inc/blocks.php'); eror(_ERORHAK); exit; }
    } else { $in = ''; }

foreach ($_GET as $var => $secvalue) {
   if ((eregi ("<[^>]*script*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*object*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*iframe*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*applet*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*meta*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*style*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*form*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*img*\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*onmouseover*\"?[^>]*>", $secvalue)) ||
   (eregi ("\([^>]*\"?[^)]*\)", $secvalue)) ||
   (eregi ("\"", $secvalue))) {
      eror (_BADYOURCODE);
      exit;
   }
}

foreach ($_POST as $secvalue) {
   if ((eregi ("<[^>]*script *\"?[^>]*>", $secvalue)) ||
   (eregi ("<[^>]*style*\"?[^>]*>", $secvalue))) {
      eror (_BADYOURCODE);
      exit;
   }
}

if ($conf['register_user'] == 1) {
      require (SN_PathRoot.'inc/function/system.php');
} else {
   require (SN_PathRoot.'inc/function/no-auth.php');
}


include (SN_PathRoot.'inc/modules.php');
include (SN_PathRoot.'inc/blocks.php');

if (file_exists (SN_PathRoot.'install')) { eror ("Инсталяция закончена удалите каталог install"); exit; }

include (SN_PathRoot.'modules/'.SN_ModuleName.'/'.$module['file']);
?>