<?php
######################################################################
# SchoolNuke 2.0 RC2: Система компьютерного тестирования
# Module: members
# File: view.php
# Path: modules/members/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
if (!defined ('SN_SiteSystem')) { Header ('Location: ../../index.php'); exit; }

inc_lang ();

function view () {
   global $conf, $db, $template, $user;
if ($user['user_id'] <= 0) { redirect (''); }
   
   $journal_id = (isset($_GET['id']))? intval($_GET['id']) : 0;
   $table_id = (isset($_GET['table']))? intval($_GET['table']) : 0;

   $row_journal = $db->sql_fetchrow ($db->sql_query ("SELECT * FROM ".SN_JOURNAL_TABLE." WHERE journal_id = '".$journal_id."' AND id_user = '".$user['user_id']."' AND results > 0"));
   $row_table = $db->sql_fetchrow ($db->sql_query ("SELECT * FROM ".SN_TABLE_TABLE." WHERE table_id = '".$table_id."'"));
  
if ($row_journal && $row_table) {
   $result = $db->sql_query ("SELECT * FROM ".$row_table['tables_log']." WHERE id_user = '".$user['user_id']."' AND journal = '".$journal_id."' AND rating > 0 GROUP BY job");
   
include (SN_PathRoot.'header.php');
 
   $template->set_filenames (array (
      'member_editprofile' => 'modules/members/member_view.tpl'
      ));

   $template->assign_vars (array (
      'V_DNOTA1' => _DNOTA1.$row_journal['lessonname'],
      'V_LEVELNAME' => $row_journal['levelname'],
	  'V_TIMES' => $row_journal['times'],
      'V_DNOTA2' => _DNOTA2.$row_journal['user_fullname'],
	  'V_DPIECES' => _DPIECES,
      'V_DOFFER' => _DOFFER,
	  'V_DATTEMPT' => _DATTEMPT,
      'V_DANSWER' => _DANSWER,
	  'V_RATING' => _RATINGFUL,
	  'V_RESULT' => _RATINGFUL.': '.$row_journal['results'],
	  'V_ABILITY' => _ABILITY.': '.$row_journal['new_result'],
	  'V_BACK' => _BACK,
      'V_BACKURL' => url (''),
	  ));
  
   while ($row = $db->sql_fetchrow ($result)) {
   	 	$template->assign_block_vars ('result', array (
       'R_JOB' => $row['job'],
	   'R_PIECES' => $row['pieces'],
	   'R_OFFER' => $row['offer'],
	   'R_ATTEMPT' => $row['attempt'],
	   'R_ANSWER' => $row['answer'],
	   'R_RATING' => (($row['rating'] >= 3) ? '<font color=#009900><strong>'.$row['rating'].'</strong></font>' : '<font color=#CC0000><strong>'. $row['rating'].'</strong></font>'),
        )); 
 }  
 	  $template->pparse ('member_editprofile');
	  
include (SN_PathRoot.'footer.php');  
} else { redirect ('');}
}
?>