<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: testing
# File: extract.php
# Path: modules/testing/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################

if (!defined ('SN_SiteSystem')) { Header ('Location: ../../index.php'); exit; }

class extract {
	var $EXTRACT_JOBMAX;		//количество заданий в тесте
	var $EXTRACT_PIECES;		//собственно само задание
    var $EXTRACT_NUMVAR;		//номер варианта
	var $EXTRACT_OFFER;			//предложение для задания
	var $EXTRACT_REPLY;			//правильный ответ из базы
	var $EXTRACT_SINGADDBOOL;	//признак дополнительного ответа
	var $EXTRACT_ADDBOOL;		//дополнительнный ответ
	var $EXTRACT_SINGBOOL;		//признак наличия ответов для ввода в строку
	var $EXTRACT_VARIANT;		//варианты ответов
	var $EXTRACT_TERM;			//признак перехода
	var $EXTRACT_NEXT;		    //переход
	var $EXTRACT_TIME;		    //время ответа
	var $EXTRACT_COMPLEX;		//
	var $EXTRACT_THEORY;		//теория
	
	// функция
	function ExtractDB($job, $num_variant = 99) {
	global $table, $db;
	$variant = array ();
	$reply = array ();

       $row_jobmax = $db->sql_fetchrow ($db->sql_query("SELECT COUNT(*) FROM ".$table['test']." WHERE test_id >'0'"));
	   $this -> EXTRACT_JOBMAX = $row_jobmax['COUNT(*)'];
	
       $row_job = $db->sql_fetchrow ($db->sql_query("SELECT * FROM ".$table['test']." WHERE test_id ='".$job."'"));

	   $this -> EXTRACT_PIECES = $row_job['question'];			// возвращаем задание
	   
       $this -> EXTRACT_COMPLEX = $row_job['complex'];
	   
   	   $this -> EXTRACT_TERM = ($row_job['next'] == '')? 0: $row_job['term']; 			//

	   $this -> EXTRACT_NEXT = $row_job['next'];	    	    //переход на задание

	   $this -> EXTRACT_TIME = $row_job['time'];	    	    //время ответа

	   $this -> EXTRACT_THEORY = $row_job['theory'];
   
       $num = $db->sql_fetchrow ($db->sql_query("SELECT COUNT(*) FROM ".$table['task']." WHERE id_test ='".$job."'"));//извлекаем количество доступных вариантов
	   $quantity = $num['COUNT(*)'] - 1;
	   srand((double) microtime()*1000000);						//определяем случайный вариант

	   $this -> EXTRACT_NUMVAR = ($num_variant > $quantity) ? $num_variant = rand(0, $quantity): $num_variant ; //номер варианта
			
	   $result_task = $db->sql_query("SELECT * FROM ".$table['task']." WHERE id_test ='".$job."'");
	   $db->sql_rowseek ($num_variant, $result_task);			//устанавливаем курсор на нужный вариант
       $row_task = $db->sql_fetchrow ($result_task);
	   
	   $id_task = $row_task['task_id'];

	   $this -> EXTRACT_OFFER = $row_task['correct'];			//это вариант для задания

	   $this -> EXTRACT_SINGADDBOOL = ($row_task['addbool'] == '') ? false : true ;  // признак наличия варианта дополнительного ответа

	   $this -> EXTRACT_ADDBOOL = $row_task['addbool']; 		//дополнительный ответ
		
	   $result_answer = $db->sql_query("SELECT * FROM ".$table['answer']." WHERE id_task ='".$id_task."'");
	   
	   $this -> EXTRACT_SINGBOOL = ($result_answer) ? $row_job['tip'] : false ; // признак наличия варианта ответа
	   
       $i = 0;
	   while ($row_answer = $db->sql_fetchrow ($result_answer)) {
	   $variant[$i] = $row_answer['answer'];
	   $reply[$i] = $row_answer['bool'];
	   $i++;
	   }
	   
       $this -> EXTRACT_VARIANT = $variant;
	   $this -> EXTRACT_REPLY = $reply;
	}	// End: function ExtractDB
} // End: class extract
?>