<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: testing
# File: index.php
# Path: modules/testing/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
if (!defined ('SN_SiteSystem')) { Header ('Location: ../../index.php'); exit; }

inc_lang();

if ((!isset($_REQUEST['id'])) || ($_REQUEST['id']== "")) { Header ('Location: ../../index.php?go=members'); exit;}

   $id_level = intval($_REQUEST['id']);
   $table = array ();
   $level = array ();
 
   $row_level = $db->sql_fetchrow ($db->sql_query ("SELECT * FROM ".SN_ALLOW_TABLE." allow, ".SN_LEVEL_TABLE." level, ".SN_LESSON_TABLE." lesson WHERE allow.allows = level.levels AND allow.lesson = level.lesson AND allow.lesson = lesson.lesson AND allow.id_user = '".$user['user_id']."' AND level.curriculum = '".$user['user_curriculum']."' AND level.level_id = '".$id_level."'"));
   
if ((!$row_level) || ($in == "test" && $row_level['status'] == "inactive" )) { Header ('Location: ../../index.php?go=members'); exit;}
   
   $level['id_allow'] = $row_level['allow_id'];
   $level['id'] = $row_level['level_id'];
   $level['allow'] = $row_level['levels'];
   $level['name'] = $row_level['levelname'];
   $level['skript'] = $row_level['skriptname'];
   $level['variant'] = $row_level['variant'] - 1;
   $level['lesson'] = $row_level['lesson'];
   $level['lessonname'] = $row_level['lessonname'];
   $level['table'] = $row_level['id_table'];
   
   $row_table = $db->sql_fetchrow ($db->sql_query ("SELECT * FROM ".SN_TABLE_TABLE." WHERE table_id = '".$row_level['id_table']."'"));
   
   $table['test'] = $row_table['tables'];
   $table['task'] = $row_table['tables_task'];
   $table['answer'] = $row_table['tables_answer'];
   $table['log'] = $row_table['tables_log'];

   if (is_file(SN_PathRoot.'modules/testing/'.$level['skript'].'/rating.php')) {
		include_once(SN_PathRoot.'modules/testing/'.$level['skript'].'/rating.php'); }
   else { include_once (SN_PathRoot.'modules/testing/rating.php'); }
	
   if (is_file(SN_PathRoot.'modules/testing/'.$level['skript'].'/extract.php')) {
		include_once(SN_PathRoot.'modules/testing/'.$level['skript'].'/extract.php'); }
   else { include_once (SN_PathRoot.'modules/testing/extract.php'); }
   	
	$extract = new extract;									// обьект извлечения данных
	$rating = new rating;									// обьект проверки ответов

	
switch ($in) {

case "test":
   $header_mod_title = _TEST.' '.$level['lessonname'].' "'.$level['name'].'"';
   include (SN_PathRoot.'modules/testing/'.$level['skript'].'/index.php');
   exit;

case "help":
   $header_mod_title = _HELP.' '.$level['lessonname'].' "'.$level['name'].'"';
   include (SN_PathRoot.'modules/testing/help.php');
   exit;
}
exit;
?>