<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: testing
# File: index.php
# Path: modules/testing/Learning/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
if (!defined ('SN_SiteSystem')) { Header ('Location: ../../index.php'); exit; }													

$sestest = & $_SESSION['sestest'];

if (!isset($_REQUEST["body"]) && !isset($_REQUEST["up"])) {
		
		$sestest['job'] = $job = 1;
		$sestest['attempt'] = $attempt = 1;
		$sestest['journal'] = $journal = $rating -> initial();				// функция инициализации сесии
		$sestest['num_variant'] = $num_variant = $level['variant'];
		$sestest['winup'] = $winup = false;
		$sestest['up'] = $up = false;
		$sestest['go_exit'] = $go_exit = false;
		
} else {													

if 	(!isset($_REQUEST["up"])) {
		$num = $sestest['attempt'];
		$rating -> checking_answer();				   						 // функция проверки правильности ответов
		$sestest['job'] = $job = $rating -> RATING_JOB;
		$sestest['attempt'] = $attempt = $rating -> RATING_ATTEMPT;
		$sestest['journal'] = $journal = $rating -> RATING_JOURNAL;
		$sestest['num_variant'] = $num_variant = ($rating -> RATING_EXIT)? $level['variant'] : $sestest['num_variant'];
		$sestest['winup'] = $winup = $rating -> RATING_WINUP;
		$sestest['go_exit'] = $go_exit = $rating -> RATING_GOEXIT;
		$truth = $rating -> RATING_TRUE;
		$sestest['up'] = $up = ($winup && !$truth) ? false : true;
		
} else {

		$job = $sestest['job'];
		$attempt = $sestest['attempt'];
		$journal = $sestest['journal'];
        $num_variant = $sestest['num_variant'];
		$winup = $sestest['winup'];
		$up = $sestest['up'];
		$go_exit = $sestest['go_exit'];
}		
		
}

///////////////////////////////////////////////////////////////////////


	if 	($up) {																// выдаем правильность ответа

	$sestest['up'] = $up = false;
	
	$true_false = ($truth) ? '<font color=#009900 size="+3">'._TRUE.'</font>' : '<font color=#CC0000 size="+3">'._FALSE.'</font>';

	   include (SN_PathRoot.'header.php');

   $template->set_filenames (array (
      'testing_up' => 'modules/testing/'.$level['skript'].'/testing_up.tpl'
      ));
   
    $template->assign_vars (array (
	  'U_URLFORM' => url('&in=test'),
      'U_THEORY' => $true_false,
	  'U_QUESTION' => '<font size="+0.5">'._QUESTION.'&nbsp;'.(($attempt == 1) ? $job - 1 : $job).';</font>',
	  'U_ATTEMPT' => '<font size="+0.5">'._ATTEMPT.'&nbsp;'.$num.':</font>',
	  'U_LEVEL' => $level['id'],
	  'U_SUBMIT' => _UPSUBMIT,
	));

   $template->pparse ('testing_up');
   include (SN_PathRoot.'footer.php');
   
exit;
}

///////////////////////////////////////////////////////////////////////
	if 	($winup) {															//  выдаем теорию вконце

	$sestest['num_variant'] = $num_variant = $level['variant'];
    $sestest['winup'] = $winup = false;
	
$extract -> ExtractDB($job-1);												// функция извлечения данных из базы
    $theory = $extract -> EXTRACT_THEORY;

	   include (SN_PathRoot.'header.php');

   $template->set_filenames (array (
      'testing_winup' => 'modules/testing/'.$level['skript'].'/testing_winup.tpl'
      ));
   
    $template->assign_vars (array (
      'U_FATAL' => '<font color=#CC0000 size="+1">'._FATAL.'</font>',
	  'U_URLFORM' => url('&in=test'),
      'U_THEORY' => $theory,
	  'U_LEVEL' => $level['id'],
	  'U_SUBMIT' => _UPSUBMIT,
	));

   $template->pparse ('testing_winup');
   include (SN_PathRoot.'footer.php');
   
exit;
}

///////////////////////////////////////////////////////////////////////////////////

if ($go_exit) { Header ('Location: ../../index.php?go=Members'); exit;}

////////////////////////////////////////////////////////////////////////

 	
$extract -> ExtractDB($job, $num_variant);			// функция извлечения данных из базы

	$offer = $extract -> EXTRACT_OFFER;
	$reply = $extract -> EXTRACT_REPLY;
	$singbool = $extract -> EXTRACT_SINGBOOL;
	$singaddbool = $extract -> EXTRACT_SINGADDBOOL;
	$alternativ = $extract -> EXTRACT_VARIANT;
	$pieces = $extract -> EXTRACT_PIECES;
	$sestest['num_variant'] = $num_variant = $extract -> EXTRACT_NUMVAR;
	
$body_reply ="";
$body_addbool = "";
$body_nul = "";
	
		if ($singbool == 4)	{				// Ввод данных
		$symm = array ();
		for ($i=0; $i<count($alternativ); $i++) { 
		$symm[$i] = $i;	}
		shuffle($symm);
			for ($i=0; $i<count($symm); $i++) { 
			    $body_reply .= '<tr><td width="1%">';
				$body_reply .= '&nbsp;<input type="text" name="variant'.$symm[$i].'" size="5" maxlength="5" />&nbsp;</td>';
			    $body_reply .= '<td>'.$alternativ[$symm[$i]].'</td></tr>'; } 
		}									//	
		
		elseif ($singbool == 3)	{			//сопоставление
        $body_reply1 ='<table width="100%" border="0" cellpadding="0" cellspacing="5">';		
		$first = array();
		for ($i=1; $i<count($reply); $i++) { 
		   $key = array_search($i, $reply);
           if ($key || ($key === 0)) {
		       $first[$key] = $reply[$key];
			    $body_reply1 .= '<tr><td width="1%">';
				$body_reply1 .= '&nbsp;<input type="text" readonly name="variant'.$key.'" value="'.$first[$key].'" size="2" />&nbsp;</td>';
			    $body_reply1 .= '<td>'.$alternativ[$key].'</td></tr>';			   
			}
		}
        $body_reply1 .= '</table>';
		$second = array_diff_assoc($reply, $first); 

		$symm = array ();
		for ($i=0; $i<count($reply); $i++) { 
		$symm[$i] = $i;	}
		shuffle($symm);
        $body_reply2 ='<table width="100%" border="0" cellpadding="0" cellspacing="5">';		
		for ($i=0; $i<count($symm); $i++) {
			if (isset($second[$symm[$i]])) {
			    $body_reply2 .= '<tr><td width="1%">';
				$body_reply2 .= '&nbsp;<select name="variant'.$symm[$i].'" style="width=50px">';
				$body_reply2 .= '<option value="0" selected></option>';
				for ($j=1; $j<=(count($reply)/2); $j++) { 
				   $body_reply2 .= '<option value="'.$j.'">'.$j.'</option>';	
				}
				$body_reply2 .= '</select>&nbsp;</td>';				
			    $body_reply2 .= '<td>'.$alternativ[$symm[$i]].'</td></tr>'; 
			}
		}
        $body_reply2 .= '</table>';
        $body_reply .= '<tr><td width="50%">'.$body_reply1.'</td>';
        $body_reply .= '<td width="50%">'.$body_reply2.'</td></tr>'; 
		}										//
        
		elseif ($singbool == 2)	{				// Хронологический порядок
		$symm = array ();
		for ($i=0; $i<count($alternativ); $i++) { 
		$symm[$i] = $i;	}
		shuffle($symm);
			for ($i=0; $i<count($symm); $i++) {
			    $body_reply .= '<tr><td width="1%">';
				$body_reply .= '&nbsp;<select name="variant'.$symm[$i].'" style="width=50px">';
				$body_reply .= '<option value="0" selected></option>';
				for ($j=1; $j<=count($reply); $j++) { 
				   $body_reply .= '<option value="'.$j.'">'.$j.'</option>';	
				}
				$body_reply .= '</select>&nbsp;</td>';				
			    $body_reply .= '<td>'.$alternativ[$symm[$i]].'</td></tr>';  } 
		}											//	
		
		elseif ($singbool == 1)	{					//Выбор значений
		$symm = array ();
		for ($i=0; $i<count($alternativ); $i++) { 
		$symm[$i] = $i;	}
		shuffle($symm);
			for ($i=0; $i<count($symm); $i++) { 
			    $body_reply .= '<tr><td width="1%">';
				$body_reply .= '&nbsp;<input type="checkbox" name="variant'.$symm[$i].'" value="1" />&nbsp;</td>';
			    $body_reply .= '<td>'.$alternativ[$symm[$i]].'</td></tr>'; } 
		}											//
		
		if ($singaddbool)	{	
		    $body_addbool .= '<tr><td>&nbsp;'._ANSWER.'&nbsp;</td>';
			$body_addbool .= '<td>&nbsp;<input name="addbool" type="text" size="50" maxlength="50" /></td></tr>'; }

		if ($singbool && $singaddbool)	{$body_nul .= '<tr><td colspan="2">&nbsp;</td></tr>';}

	
   include (SN_PathRoot.'header.php');

   $template->set_filenames (array (
      'testing_body' => 'modules/testing/'.$level['skript'].'/testing_body.tpl'
      ));
   
    $template->assign_vars (array (
      'B_PIECES' => $pieces,
	  'B_URLFORM' => url('&in=test'),
      'B_OFFER' => $offer,
	  'B_BODY' => $body_reply.$body_nul.$body_addbool,
	  'B_QUESTION' => _QUESTION.'&nbsp;'.$job,
      'B_ATTEMPT' => _ATTEMPT.'&nbsp;'.$attempt,
	  'B_LEVEL' => $level['id'],
	  'B_SUBMIT' => _SUBMIT,
	));

   $template->pparse ('testing_body');
   include (SN_PathRoot.'footer.php'); 
?>