<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# File: footer.php
# Path: /
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# This program is free software. You can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
######################################################################
# File: footer.php
# Path: /
# Version: 2.0.4
######################################################################
if (!defined ('SN_SiteSystem')) { Header ('Location: index.php'); exit; }

global $gzip_method, $do_gzip_compress;

function footer () {
   global $db, $start_time, $start_memory;
   $end_time = get_microtime ();
   $total_time = ($end_time - $start_time);
   $total_time = ""._PAGEGENERATION.": ".substr ($total_time, 0,5)." "._SEC.". "._ALL." ".$db->num_queries." ".num_in_words ($db->num_queries, ""._BASEQUERY.", "._BASEQUERY2.", "._BASEQUERY3."")." "._INBASE.".";
   $copy_text = '';
   $total_memory = '';
   if (function_exists ('memory_get_usage')) {
      $stop_memory = memory_get_usage ();
      $total_memory = ' Mem.: '.($stop_memory-$start_memory);
   } 
  /*else if (strpos( strtolower($_SERVER['SERVER_SOFTWARE']), 'win') != false) {
      // Windows workaround
      $output = array();
      exec('tasklist /FI "PID eq ' . getmypid() . '" /FO LIST', $output);
      $stop_memory = str_replace(".", '', substr($output[5], strpos($output[5], ':') + 1, -2))*1024;
      $total_memory = ' Mem.: '.($stop_memory-$start_memory);
   } */
   return $total_time.$total_memory.'<br>'.$copy_text;
}

block ('b');

if (_SNSS_THEME & SN_BLOCK_RIGHT) {
   $template->set_filenames (array (
      'page_right' => 'page_right.tpl'
      ));
   $template->assign_vars (array (
      'C_BLOCK' => 'block-right',
      ));
   $template->pparse ('page_right');

   block ('r');
   }

if (_SNSS_THEME & SN_BLOCK_FOOTER) {
   $template->set_filenames (array (
      'page_bottom' => 'page_bottom.tpl'
   ));
   $template->assign_vars(array(
      'C_SPAN' => (bool)(_SNSS_THEME & SN_BLOCK_LEFT)*2+(bool)(_SNSS_THEME & SN_BLOCK_RIGHT)*2+1,
      'C_BLOCK' => 'block-footer',
      ));
   $template->pparse ('page_bottom');

   block ('f');
}

$template->set_filenames (array (
   'page_footer' => 'page_footer.tpl'
   ));

$template->assign_vars (array (
   'T_COPYRIGHT' => footer ()
   ));
$template->pparse ("page_footer");

echo '</body></html>';

if(($conf['gzip_method'] == 1) AND ($do_gzip_compress)) {
   $gzip_contents = ob_get_contents ();
   ob_end_clean ();
   $gzip_size = strlen ($gzip_contents);
   $gzip_crc = crc32 ($gzip_contents);
   $gzip_contents = gzcompress ($gzip_contents, 9);
   $gzip_contents = substr ($gzip_contents, 0, strlen ($gzip_contents) - 4);
   echo "\x1f\x8b\x08\x00\x00\x00\x00\x00";
   echo $gzip_contents;
   echo pack('V', $gzip_crc);
   echo pack('V', $gzip_size);
}
?>