######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: Install
# File: mysql_basic.sql
# Path: install/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
######################################################################
# SmallNuke 2: Sites Build System
# ============================================
# Copyright (c) 2006 by SmallNuke Group
# License: GNU/GPL
# E-Mail support@smallnuke.com
# WEB http://www.smallnuke.com
# ============================================
# Module: Install
# File: mysql_basic.sql
# Path: install/
# Version: 2.0.4
######################################################################

INSERT INTO `school_admins`  VALUES (1, 'admin', 'Администратор системы', 'super', '', '', NULL, '', '', 'schoolnuke@gmail.com', 'super');



INSERT INTO `school_blocks` (`block_id`, `title_ru`, `title_en`, `text`, `file_name`, `in_module`, `no_module`, `position`, `weight`, `view`, `language`, `status`) VALUES
(1, 'Навигация', 'Navigation', '<br />', 'block-modules.php', 'all', 'all', 'l', 1, 0, '', 1),
(2, 'Авторизация', 'Login', '<br />', 'block-login.php', 'all', 'all', 'l', 2, 0, '', 1),
(3, 'Кто на сайте', 'Who on line', '<br />', 'block-online.php', 'all', 'all', 'l', 3, 0, '', 1);


INSERT INTO `school_members` VALUES
(-1, 'Anonymous', '', 0, '', '', UNIX_TIMESTAMP(), '', NULL, NULL, '', '0', 0);


INSERT INTO `school_modules` (`mod_id`, `title`, `title_ru`, `title_en`, `view`, `status`, `theme`, `link`, `position`, `line`) VALUES
(1, 'about', 'О проекте', 'About', 0, 1, 51, 1, 1, 0),
(2, 'members', 'Личный кабинет', 'Members', 0, 1, 51, 1, 3, 0),
(3, 'testing', 'Тестирование', 'Test', 1, 1, 0, 0, 2, 0);

######################################################################
# Module: About
# Version: 0.1
######################################################################

INSERT INTO `school_mod_about` (`lang`, `title`, `name`, `keywords`, `text`, `status`, `date`) VALUES
('ru', 'Добро пожаловать в  SchoolNuke.', 'Cистема компьютерного тестирования и обучения SchoolNuke.', 'Компьютерное тестирование', '<table cellspacing="0" cellpadding="0" width="100%" border="0"><tbody><tr><td width="2%">&nbsp;</td><td align="center"><p class="base_txt">Система компьютерного тестирования и обучения, включающая в себя все инструменты, необходимые для создания тестов, их проведения, хранения и обработки результатов, являющаяся свободным программным обеспечение с открытым кодом и распространяющаяся под лицензией GNU&nbsp;GPL.</p></td><td width="2%">&nbsp;</td><td align="right"><img src="/uploads/images/About/full.png" /></td><td width="2%">&nbsp;</td></tr></tbody></table>', 1, UNIX_TIMESTAMP());

######################################################################
#
#
######################################################################
