<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: members
# File: index.php
# Path: modules/members/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
if (!defined ('SN_SiteSystem')) { Header ('Location: ../../index.php'); exit; }

function login () {
   global $conf, $template, $user;
   inc_lang ();

   // Если уже залогиненый
   if (0 < $user['user_id']) { redirect (''); }

   include (SN_PathRoot.'header.php');
   $template->set_filenames (array (
      'member_login' => 'modules/members/member_login.tpl'
      ));
   $template->assign_vars (array (
      'S_LOGIN_ACTION' => url (''),
      'L_LOGINUSER' => _LOGINUSER,
      'L_NICKNAME' => _NICKNAME,
      'L_PASSWORD' => _PASSWORD,
      'L_ENTERUSER' => _ENTERUSER,
      ));

   $template->pparse ('member_login');
   include (SN_PathRoot.'footer.php');

}

function check_login () {
   redirect ('');
}

switch ($in) {

case "lost_pass":
   include (SN_PathRoot.'modules/members/lost_pass.php');
   exit;

case "check_login":
   check_login ();
   exit;

case "login":
   login ();
   exit;
   
case "view":
   include (SN_PathRoot.'modules/members/view.php');
   view ();
   exit;
   
case "code":
   include (SN_PathRoot.'inc/function/kcaptcha.php');
   $captcha = new KCAPTCHA ();
   $captcha->showImage (isset ($_SESSION['ModMembersCode'])? trim ($_SESSION['ModMembersCode']) : '');
   exit;
}

inc_lang ();
if (0 < $user['user_id']) {

   $page = (isset($_GET['page']))? intval($_GET['page']): 0;
   $num = $db->sql_fetchrow($db->sql_query("SELECT COUNT(*) FROM ".SN_JOURNAL_TABLE." WHERE id_user = '".$user['user_id']."'"));
   $all_page = ($num['COUNT(*)'])? $num['COUNT(*)']: 1;
   $per_page = 11;

   $pages = generate_page (url (''), $all_page, $per_page, $page);
   $row_group = $db->sql_fetchrow ($db->sql_query("SELECT * FROM ".SN_GROUP_TABLE." WHERE groups = '".$user['user_group']."'"));
   $result_allow = $db->sql_query ("SELECT * FROM ".SN_ALLOW_TABLE." allow, ".SN_LESSON_TABLE." lesson WHERE allow.lesson = lesson.lesson AND allow.id_user = '".$user['user_id']."' ORDER BY lesson.lessonname");
  
   include (SN_PathRoot.'header.php');
   $template->set_filenames (array (
      'member_editprofile' => 'modules/members/member_editprofile.tpl'
      ));


   $template->assign_vars (array (
      'M_USERGIVEN' => _USERGIVEN,
      'M_FIO' => _FIO,
	  'M_USERS' => $user['user_fullname'],
      'M_NICKNAME' => _NICKNAME,
	  'M_LOGIN' => $user['username'],
      'M_GROUP' => _GROUP,
	  'M_GROUPS' => $row_group['groupname'].' ('.$user['user_group'].')',
      'M_CURRICULUM' => _CURRICULUM,
	  'M_CURRICULUMS' => $row_group['curriculum'],
      'M_PASSWORD' => _PASSWORD,
	  'M_SENDPASS' => url ('&in=lost_pass'),
	  'M_CHANGE' => _CHANGE,
      'M_LEVEL' => _LEVEL,
      'M_LEVELNOTE' => _LEVELNOTE,
	  'M_RESULT' => _RESULT,
	  'M_RESULTNOTE' => _RESULTNOTE,
	  'M_LESSON' => _LESSON,
	  'M_RESULTTIME' => _RESULTTIME,
	  'M_RATING' => _RATING,
	  'M_ABILITY' => _ABILITY,
	  'M_PAGES' => $pages,
      ));
	  
while ($row_allow = $db->sql_fetchrow ($result_allow)) {
	  $levelname = '&nbsp;';
	  $urlallow ='#';
	  $helpname = '&nbsp;';
	  $urlhelp = '#';

      $lessonname = $row_allow['lessonname']; 
      $row_level = $db->sql_fetchrow($db->sql_query("SELECT * FROM ".SN_LEVEL_TABLE." WHERE levels = '".$row_allow['allows']."' AND curriculum = '".$user['user_curriculum']."' AND lesson = '".$row_allow['lesson']."'"));
	        if ($row_allow['allows'] == $row_level['levels']) {
			if ($row_level['status'] == 'active') {
		     $urlallow = 'index.php?go=Testing&in=test&id='.$row_level['level_id'];}
			 $levelname = $row_level['levelname'];
			 $urlhelp = 'index.php?go=Testing&in=help&id='.$row_level['level_id'];
			 $helpname = _HELP;
	        }

	$template->assign_block_vars ('levels', array (
       'M_LESSONNAME' => $lessonname,
       'M_ALLOWS' => $row_allow['allows'],
	   'M_LEVELNAME' => $levelname,
	   'M_URLALLOW' => $urlallow,
	   'M_HELP' => $helpname,
	   'M_URLHELP' => $urlhelp,
        ));  
} 
    $result_journal = $db->sql_query ("SELECT * FROM ".SN_JOURNAL_TABLE." WHERE id_user = '".$user['user_id']."' ORDER BY times DESC LIMIT ".$page.", ".$per_page);
	while ($row_journal = $db->sql_fetchrow ($result_journal)) {
	 	$template->assign_block_vars ('result', array (
	   'R_VIEW' => ($row_journal['results']) ? '<a href="'.url ('&in=view&id='.$row_journal['journal_id'].'&table='.$row_journal['id_table']).'"><img src="template/default/images/accept.gif" alt="'._ALT.'" width="16" height="16" border="0" /></a>' : '<img src="template/default/images/block.gif" alt="'._BLOCK.'" width="16" height="16" border="0" />',
       'R_LESSONNAME' => $row_journal['lessonname'],
	   'R_LEVELNAME' => $row_journal['levelname'],
	   'R_RESULTTIME' => $row_journal['times'],
	   'R_COMMENT' => ($row_journal['results'])? $row_journal['comments']: $row_journal['new_result'],
       'R_ID' => $row_journal['journal_id'],	   
       'R_RATING' => ($row_journal['results'])? $row_journal['results']:'-',
	   'R_PERSENT' => $row_journal['percent'],
	   'R_NEWRESULT' => $row_journal['new_result'],
        ));  
	 }
	 
	  $template->pparse ('member_editprofile');
   include (SN_PathRoot.'footer.php');

} else {
   login();
}
?>