<?php
######################################################################
# SchoolNuke 2.0: Система компьютерного тестирования
# Module: Testing
# File: rating.php
# Path: modules/Testing/
# ============================================
# Copyright (c) 2009  Королёв Игорь
# E-Mail: schoolnuke@gmail.com
# WEB: http://www.schoolnuke.ru
# ============================================
# Методика тестирования разработана Карташовой Еленой
# ЕГУ им. И.А.Бунина
# Елец - 2009г.
# ============================================
# Данная программа является свободным программным обеспечением.
# Вы вправе распространять ее и/или модифицировать в соответствии с условиями версии 2
# либо по вашему выбору с условиями более поздней версии Стандартной Общественной Лицензии GNU,
# опубликованной Free Software Foundation.
# Программа распространяется в надежде на то, что она будет вам полезной,
# распространяется БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе 
# ГАРАНТИИ ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ.
# Для получения более подробной информации ознакомьтесь со Стандартной Общественной Лицензией GNU.
######################################################################
if (!defined ('SN_SiteSystem')) { Header ('Location: ../../index.php'); exit; }

class rating {
	var $RATING_JOB;
	var $RATING_ATTEMPT;
	var $RATING_REPLY;
	var $RATING_JOURNAL;
	var $RATING_WINUP;
	var $RATING_GOEXIT;
	var $RATING_EXIT;
	var $RATING_TRUE;
	var $RATING_TIME;
	
	function initial () {											//инициализация новой записи в журнале
		global $user, $level, $db;
		return $db->sql_nextid($db->sql_query("INSERT INTO ".SN_JOURNAL_TABLE."(id_table, id_user, username, user_fullname, lesson, lessonname, id_level, levelname, times, results, percent, new_result, comments)
		VALUES ('".$level['table']."', '".$user["user_id"]."', '".$user["username"]."', '".$user["user_fullname"]."', '".$level["lesson"]."', '".$level["lessonname"]."', '".$level["allow"]."', '".$level["name"]."', NOW(''), '0', '0', '"._FATALTEST."', '')"));
	} 

	

	// функция извлечения правильного ответа пользователем
	function checking_answer ($p = 3) {
	global $extract, $user, $level, $table, $db;
	
	$p = ($p > 3) ? 3 : $p ;
		$journal = 0;
		$reply_user = array ();										// задаем переменную ответа пользователя
		$reply_data = "";
		$exit = false;
		$winup= false;
		$go_exit = false;
		$ctime = false;
		$stop_time = time ();

		$sestest = & $_SESSION['sestest'];
		$job = $sestest["job"];
		$attempt = $sestest["attempt"];
		$journal = $sestest["journal"];
		$num_variant = $sestest["num_variant"];
		$start_time = (isset($sestest["time"])) ? $sestest["time"]: 0 ;

		
		
		$extract -> ExtractDB($job, $num_variant);
		$job_exit = $extract -> EXTRACT_JOBMAX + 1;
		$pieces = $extract -> EXTRACT_PIECES;
		$offer = $extract -> EXTRACT_OFFER;
		$singbool = $extract -> EXTRACT_SINGBOOL;
		$reply = $extract -> EXTRACT_REPLY;
		$singaddbool = $extract -> EXTRACT_SINGADDBOOL;
		$alternativ = $extract -> EXTRACT_VARIANT;
		$complex = $extract -> EXTRACT_COMPLEX;
        $term = $extract -> EXTRACT_TERM;
		$next = $extract -> EXTRACT_NEXT;
        $time = $extract -> EXTRACT_TIME;		
		
		if ($singbool) {	
	for ($i=0; $i<count($alternativ); $i++) {						// проверяем правельность ответов и извлекаем его
		if (isset($_POST["variant".$i])) {
		$reply_data = $reply_data.($i+1).") ".$alternativ[$i];
		if ($singbool == 4) {$reply_data .= "&nbsp;&nbsp;&nbsp;"._VALUE .trim($_POST["variant".$i])."<br />";}
		elseif ($singbool == 3) {$reply_data .= "&nbsp;&nbsp;&nbsp;"._SVALUE .trim($_POST["variant".$i])."<br />";}
		elseif ($singbool == 2) {$reply_data .= "&nbsp;&nbsp;&nbsp;"._HVALUE .trim($_POST["variant".$i])."<br />";}
		else {$reply_data .= '<br />';}
		$reply_user[$i] = trim($_POST["variant".$i]); }
		else {$reply_user[$i] = 0;} }
	}
	if ($singaddbool) {												// если вводился дополнительный параметр то прибавляем его к ответу
		$reply['addbool'] = $extract -> EXTRACT_ADDBOOL;
		$reply_data = $reply_data.': '.substr (str_replace ("\\'", "''", str_replace ("'", "\'", rtrim (htmlspecialchars (str_replace ("\'", "'", trim (strip_tags ($_POST["addbool"])))), "\\"))), 0, 25)."\r\n";
		$reply_user['addbool'] = trim($_POST["addbool"]);}

	if ($complex == "C") { $max_rating = 2;	}
	elseif ($complex == "B") { $max_rating = 1.6; }
	else { $max_rating = 1; }
	
	if ($reply_user == $reply || $attempt >= $p) {					// если ответ верный переходим к следующему вопросу
		$exit = true;
		$true_false = true;
		$ocen = 6 - $attempt;
		
		if (($time != 0) && ($stop_time - $start_time > $time) && ($p == 1)) {		// привешение лимита времени
		$ctime = true;
		$reply_data = $reply_data.'<br /><font color=red>*&nbsp;'._TIME."</font>\r\n";
		}
		
		if (($reply_user != $reply && $attempt == $p) ||($attempt > $p) || $ctime) {
			$ocen = 2;
			$winup=true;
			$true_false = false;
		}
		if ($complex == "C") {
			switch ($ocen) { 
			case 5: $new_rating = 2; break;
			case 4: $new_rating = 1.5; break;
			case 3: $new_rating = 1; break;
           default: $new_rating = 0;}
		}elseif ($complex == "B") {
			switch ($ocen) { 
			case 5: $new_rating = 1.6; break;
			case 4: $new_rating = 1.2; break;
			case 3: $new_rating = 0.8; break;
           default: $new_rating = 0;}
		}else{
			switch ($ocen) { 
			case 5: $new_rating = 1; break;
			case 4: $new_rating = 0.75; break;
			case 3: $new_rating = 0.5; break;
           default: $new_rating = 0;}
		}
		
		$check_record = $db->sql_numrows($db->sql_query("SELECT * FROM ".$table['log']." WHERE levels='".$level["allow"]."' AND journal='".$journal."' AND job='".$job."' AND rating > '0'"));

		if (!($check_record)) {
		$db->sql_query("INSERT INTO ".$table['log']." (id_user, levels, journal, job, attempt, pieces, offer, answer, rating, new_rating, max_rating) VALUES ('".$user["user_id"]."', '".$level["allow"]."', '".$journal."', '".$job."', '".$attempt."', '".$pieces."', '".$offer."', '".$reply_data."', '".$ocen."', '".$new_rating."', '".$max_rating."')");
		}
		if ((!($check_record)) || ($attempt >= $p)) {
		$job = ($term == 1)? $next : $job + 1;
		$job = ($term == 2 && $true_false)? $next : $job;
		$job = ($term == 3 && !$true_false)? $next : $job;		
		$attempt = 0;}
		
	} else {
		$true_false = false;
		$check_record = $db->sql_numrows($db->sql_query("SELECT * FROM ".$table['log']." WHERE levels='".$level["allow"]."' AND journal='".$journal."' AND job='".$job."' AND attempt='".$attempt."'"));
		if (!($check_record)) {
		$db->sql_query("INSERT INTO ".$table['log']." (id_user, levels, journal, job, attempt, pieces, offer, answer, rating, new_rating, max_rating) VALUES ('".$user["user_id"]."', '".$level["allow"]."', '".$journal."', '".$job."', '".$attempt."', '".$pieces."', '".$offer."', '".$reply_data."', '0', '0', '0')");
		}	
	}
	
	if (($job_exit <= $job) && ($exit)) { 				// если блок закончен занести оценку в базу и перейти в домашний каталог
//!!!!????        $row = $db->sql_fetchrow ($db->sql_query("SELECT AVG(rating) FROM ".$table['log']." WHERE journal ='".$journal."' AND rating > '0' "));
//!!!!????        $itog = round ($row['AVG(rating)']);
        $row = $db->sql_fetchrow ($db->sql_query("SELECT SUM(new_rating) FROM ".$table['log']." WHERE journal ='".$journal."'"));
		$value = $row['SUM(new_rating)'];
		$row = $db->sql_fetchrow ($db->sql_query("SELECT SUM(max_rating) FROM ".$table['log']." WHERE journal ='".$journal."'"));
	    $max_value = $row['SUM(max_rating)'];
		$new_itog = round($value*100/$max_value);
		if (99 < $new_itog) { $new_result = _NR5U; $itog = 5;}
		elseif ( 94 < $new_itog) { $new_result = _NR5; $itog = 5;}
		elseif ( 90 < $new_itog) { $new_result = _NR5D; $itog = 4;}
		elseif ( 84 < $new_itog) { $new_result = _NR4U; $itog = 4;}
		elseif ( 74 < $new_itog) { $new_result = _NR4; $itog = 4;}
		elseif ( 49 < $new_itog) { $new_result = _NR3; $itog = 3;}
		elseif ( 44 < $new_itog) { $new_result = _NR3D; $itog = 3;}
		elseif ( 24 < $new_itog) { $new_result = _NR2; $itog = 2;}
		elseif (  9 < $new_itog) { $new_result = _NR1U; $itog = 2;}
		else { $new_result = _NR1; $itog = 1;}
		$db->sql_query("UPDATE ".SN_JOURNAL_TABLE." SET results = '".$itog."',percent= '".$new_itog."', new_result= '".$new_result."', comments= '"._ESTIMATION."'  WHERE journal_id='".$journal."'"); //заносим оценку в базу сесии
		$lev = $level['allow']+1;
		$db->sql_query("UPDATE ".SN_ALLOW_TABLE." SET allows = '".$lev."' WHERE allow_id='".$level['id_allow']."'");
		$go_exit = true;
		}

	
		$attempt++;
		$this -> RATING_GOEXIT = $go_exit;
		$this -> RATING_JOURNAL = $journal;
		$this -> RATING_WINUP = $winup;
		$this -> RATING_JOB = $job;
		$this -> RATING_ATTEMPT = $attempt;
		$this -> RATING_EXIT = $exit;
		$this -> RATING_TRUE = $true_false;
		$this -> RATING_TIME = $ctime;

	}	// End: function 
	
} // End: class rating
?>